#!/bin/sh


PROG="$0"
CMDLINE="$*"
usage() {
    echo "$PROG [-native] [-I dir .. -I dir] Module"
}

INCLUDES=""
MODULES=""
NATIVE=0
INTER=0
while true; do
    case $1 in
        -I)
            dir=`echo "$2" | sed "s:^+:$(ocamlc -where)/:"`
            INCLUDES="$INCLUDES
$2"
            shift
            ;;
        -native)
            NATIVE=1
            ;;
        -inter)
            INTER=1
            ;;
        [A-Z]*)
                MODULES="$MODULES $1"
            ;;
        *)
            echo "ERROR: '$1'"
            usage
            exit 2
            ;;
    esac
    shift
    if test "$#" -eq 0; then break; fi
done
if test "$NATIVE" = "1"; then
    ext=cmx
else
    ext=cmo
fi

for MODULE in $MODULES; do
    module="$(echo $MODULE | cut -b1 | tr A-Z a-z)$(echo $MODULE | cut -b2-)"
    echo "$INCLUDES" | while read include; do
        base="$include/$module"
        if test -z "$include"; then continue; fi
        if test  \( "$INTER" = "1" \) -a \( -f "$base".mli \) ; then
                echo -n "$base"."cmi "
        elif test -f "$base".ml -o -f "$base".mly -o -f "$base".mll -o -f "$base".pack; then
            echo -n "$base"."$ext "
            break
        elif test -f "$base".mli; then
            echo -n "$base"."cmi "
            break
        fi
    done
done
echo
